Subject: Re: [PATCH] Make virtio_net support carrier detection

From: Rusty Russell <[email-masked]>
Date: Thu, 12 Mar 2009 19:46:24 +1030

On Thursday 12 March 2009 18:14:44 Pantelis Koukousoulas wrote:
> On Thu, Mar 12, 2009 at 9:29 AM, Rusty Russell <[email-masked]> wrote:
> > On Wednesday 11 March 2009 22:27:22 Pantelis Koukousoulas wrote:
> >> For now the semantics are simple: There is always carrier.
> >>
> >> This allows a seamless experience with e.g., qemu/kvm
> >> where NetworkManager just configures and sets up
> >> everything automagically.
> >
> > So, NetworkManager ignores the device because it doesn't support
> > carrier detection?
> 
> It doesn't ignore it, it just doesn't enable it by default, like it does for
> those that do report carrier.
> 
> But the user experience is that on real hardware you just boot a livecd
> and see your network "just working" (and the familiar icon with the 2
> computers indicating that), while under e.g., KVM/virtio you get
> non-working network / an icon with a red X and you have to
> figure out to left click on it and select eth0 to get things to work.
> 
> Some newer versions of NetworkManager seem to assume that
> if no carrier detection is supported then carrier is on by default
> so it should work for those, but that assumption seems like
> a worse hack than this patch :)

No, that's absolutely sane behavior, the previous was buggy.  If a network
doesn't support carrier, you shouldn't look for it.

Since they've fixed this in Network Manager, I'm not tempted to lie about it
in the driver (though the distributions might choose to).

Rusty.